unit Child;

interface

uses
    Windows, Classes, SysUtils, Graphics, Forms, Controls, StdCtrls, ShellNotify,
  ExtCtrls, ComCtrls;

type
  TChildForm = class(TForm)
    Panel1: TPanel;
    EditRowCount: TEdit;
    UpdnRowCount: TUpDown;
    Label1: TLabel;
    MemoTail: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    LblSize: TLabel;
    LblModified: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    Killed: Boolean;
    TargetSize: integer;
    TargetModified: TDateTime;
  public
    TargetFile: string;
    ShellNotifier: TShellChangeNotifier;
    procedure OnChangeMethod();
  end;

implementation

{$R *.dfm}

uses
    Main, fjUtil;

//-----------------------------------------------------------------------------
//  Őݒ
procedure TChildForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caFree;
    //  Ď~
    Killed := true;
    ShellNotifier.OnChange := nil;
end;

//-----------------------------------------------------------------------------
//  EBhEIXg폜
procedure TChildForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    MainForm.CallOnReleaseMDIChild(Self);
end;

//-----------------------------------------------------------------------------
//  EBhEIXgŎI
procedure TChildForm.FormActivate(Sender: TObject);
begin
    MainForm.CallOnActivateMDIChild(Self);
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TChildForm.FormCreate(Sender: TObject);
begin
    //  oϐ
    TargetSize := 0;
    TargetModified := 0;
    Killed := false;

    //  ύXʒmNX쐬
    ShellNotifier := TShellChangeNotifier.Create();
    //  ύX́uTCYύXvuݓύXv
    ShellNotifier.NotifyFilters := [nfSizeChange, nfWriteChange];
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TChildForm.FormDestroy(Sender: TObject);
begin
    //  NX
    ShellNotifier.Free;
    ShellNotifier := nil;
end;

//-----------------------------------------------------------------------------
//  ύXʒmCxg
procedure TChildForm.OnChangeMethod();
var
    OldSize: integer;
    OldModified: TDateTime;
begin
    if (Killed) then Exit;

    //  Ώۃt@C̑݃`FbN
    if FileExists(TargetFile) then
    begin
        //  ꎞ~
        ShellNotifier.OnChange := nil;

        //  obNAbv
        OldSize     := TargetSize;
        OldModified := TargetModified;

        //  TCY擾
        TargetSize := FileSizeByFileSize(TargetFile);

        //  ύX擾
        TargetModified := FileModifiedByGetFileTime(TargetFile);

        //  ύXĂ邩H
        if (OldSize <> TargetSize) or (OldModified <> TargetModified) then
        begin
            //  \
            Tail(TargetFile, MemoTail.Lines, UpdnRowCount.Position);

            //  ߂Ă̏ꍇ͒
            if (OldSize = 0) then OldSize := TargetSize;
            if (OldModified = 0) then OldModified := TargetModified;

            //  \-2
            LblSize.Caption := Format('%s (%s)', [
                                    SizeText(TargetSize),
                                    SizeText(TargetSize - OldSize)
                                ]);

            LblModified.Caption := Format('%s (%s)', [
                                    DateText(TargetModified),
                                    DateText(OldModified, TargetModified)
                                ]);
        end;

        //  ĊJ
        ShellNotifier.OnChange := OnChangeMethod;
    end;
end;

end.
